// http://www.mikrocontroller.net/topic/280443#new
// wizard2001  adapted for STM32VLdiscovery (24MHz)
#include "delay.h"
#include "stm32f10x.h"
//--------------------------------------------
// for 24 MHz @ Optimization-Level -Os
//--------------------------------------------
#define COUNTS_PER_MICROSECOND 8
inline void delay_us(unsigned int d)
{
  unsigned int count = d * COUNTS_PER_MICROSECOND - 2;
  __asm volatile(" mov r0, %[count]  \n\t"
              "1: subs r0, #1        \n\t"
              "   bhi 1b             \n\t"
                :
                : [count] "r" (count)
                : "r0");
}

//--------------------------------------------
// for 24 MHz @ Optimization-Level -Os
//--------------------------------------------
void delay_ms(unsigned int d)
{
  while (d--) delay_us(999);
}
