//--------------------------------------------------------------
// File     : wcd2704.c     Datum    :  10.04.2013
// Version  : 1.1         wizard2001    21.04.2013
// CPU      : STM32F4       IDE      :  CooCox CoIDE 1.7.1
// Funktion : LCD WDC2704 Display Funktionen
//--------------------------------------------------------------
//--------------------------- Includes
#include "stm32f10x.h"
#include "ws2812.h"
#include "stdlib.h"
//--------------------------- Variable
WS_LED_t WS_LEDa[Max_LED];                                 // aktueller Wert
WS_LED_t WS_LEDs[Max_LED];                                 // Ziel Wert

//--------------------------- Konstanten
const uint8_t PWMtab[32] =
{    0, 1, 2, 2, 2, 3, 3, 4, 5, 6, 7, 8, 10, 11, 13, 16, 19, 23,
    27, 32, 38, 45, 54, 64, 76, 91, 108, 128, 152, 181, 215, 255
};
//--------------------------- LCD Init
void WS2812_init(void)                                     // init GPIOs
{
  GPIO_InitTypeDef GPIO_InitStructure;

  RCC_APB2PeriphClockCmd(dat_GPIO_CLK | led_GPIO_CLK, ENABLE);

  GPIO_InitStructure.GPIO_Pin = Dout | Dext;               // Ausgang PB8-9 setzen
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(dat_port, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Pin = LED3 | LED4;               // Ausgang PC8-9 setzen
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(led_port, &GPIO_InitStructure);
}

WS_LED_t rnd_color(void)                                   // Zufallswerte generieren
{
  WS_LED_t WS_rnd;

  WS_rnd.G = (uint8_t)(rand() % 32);
  WS_rnd.R = (uint8_t)(rand() % 32);
  WS_rnd.B = (uint8_t)(rand() % 32);
  return(WS_rnd);
}

void LED_init(void)
{
  for (uint8_t i=0; i<Max_LED; i++) { WS_LEDa[i] = rnd_color();}  // GRB
}

void WS2812_dimm(void)                                     // alle LEDs GRB
{                                                          // zwischen ZUfallswerten
                                                           // dimmen
  for (uint8_t i=1; i<Max_LED; i++)
  {
    if (WS_LEDa[i].G == WS_LEDs[i].G)
    {
      WS_LEDs[i].G = (uint8_t)(rand() % 32);;
    }
    if (WS_LEDa[i].G < WS_LEDs[i].G)  WS_LEDa[i].G++;
                                 else WS_LEDa[i].G--;
    if (WS_LEDa[i].R == WS_LEDs[i].R)
    {
      WS_LEDs[i].R = (uint8_t)(rand() % 32);;
    }
    if (WS_LEDa[i].R < WS_LEDs[i].R)  WS_LEDa[i].R++;
                                 else WS_LEDa[i].R--;
    if (WS_LEDa[i].B == WS_LEDs[i].B)
    {
      WS_LEDs[i].B = (uint8_t)(rand() % 32);;
    }
    if (WS_LEDa[i].B < WS_LEDs[i].B)  WS_LEDa[i].B++;
                                 else WS_LEDa[i].B--;
  }
}

void WS2812_wr(uint8_t nLED)
{
  uint32_t mask;                                           // Bitmask
  uint32_t color = 0;
  uint8_t n;

  for (n=0; n<nLED; n++)
  {
    mask = 0x800000;
    color = (PWMtab[WS_LEDa[n].G]<<16) |
    		(PWMtab[WS_LEDa[n].R]<<8) |
    		(PWMtab[WS_LEDa[n].B]);

	while (mask)                                           // 24 Bit
    {
      Dout_H;
      if (color & mask)		                               // check bit
      {
        __asm volatile(" nop ");
        __asm volatile(" nop ");
        __asm volatile(" nop ");
        __asm volatile(" nop ");
        __asm volatile(" nop ");
        __asm volatile(" nop ");
        Dout_L;
      } else
      {
        Dout_L;
        __asm volatile(" nop ");
        __asm volatile(" nop ");
        __asm volatile(" nop ");
        __asm volatile(" nop ");
        __asm volatile(" nop ");
        __asm volatile(" nop ");
        __asm volatile(" nop ");
      }
      mask >>= 1;			// mask for next Bit
	}
  }
}
