//--------------------------------------------------------------
// File     : ws2812.h    wizard2001    27.04.2013
//--------------------------------------------------------------
#ifndef __WS2812_H
#define __WS2812_H
//--------------------------- Includes
#include "stm32f10x_conf.h"

#define Max_LED         30

typedef struct {
	uint8_t  G;
	uint8_t  R;
	uint8_t  B;
} WS_LED_t;

//--------------------------- Defines Pins, Ports
#define Dext            GPIO_Pin_8                         // check
#define Dout            GPIO_Pin_9                         // Dout for WS2812
#define dat_port        GPIOB                              // Port B
#define dat_GPIO_CLK    RCC_APB2Periph_GPIOB

#define LED3            GPIO_Pin_9                         // Board LEDs
#define LED4            GPIO_Pin_8
#define led_port        GPIOC
#define led_GPIO_CLK    RCC_APB2Periph_GPIOC

//--------------------------- Macros
#define LED3_on    led_port->ODR &= ~LED3;                 // LED3 on
#define LED3_off   led_port->ODR |=  LED3;                 // LED3 off
#define LED4_on    led_port->ODR &= ~LED4;                 // LED4 on
#define LED4_off   led_port->ODR |=  LED4;                 // LED4 off
#define Dout_L     dat_port->ODR &= ~Dout;                 // DatPin Low
#define Dout_H     dat_port->ODR |=  Dout;                 // DatPin Hight
//--------------------------- Globale Funktionen
void WS2812_init(void);
void LED_init(void);
void WS2812_wr(uint8_t);
void WS2812_dimm(void);
void ctrl_init(void);                                      // init GPIO for Dout & LEDs
//--------------------------------------------------------------
#endif // __WDC2704_H
